/*
    SPDX-License-Identifier: GPL-3.0

    Copyright (C) 2020-2025  Jevgenijs Protopopovs

    This file is part of Kefir project.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KEFIR_AST_BASE_H_
#define KEFIR_AST_BASE_H_

#include "kefir/core/basic-types.h"

// Forward declarations
typedef struct kefir_ast_type kefir_ast_type_t;
typedef struct kefir_ast_type_traits kefir_ast_type_traits_t;
typedef struct kefir_ast_node_base kefir_ast_node_base_t;
typedef struct kefir_ast_scoped_identifier kefir_ast_scoped_identifier_t;
typedef struct kefir_ast_context kefir_ast_context_t;
typedef struct kefir_ast_type_bundle kefir_ast_type_bundle_t;
typedef struct kefir_ast_constant_expression kefir_ast_constant_expression_t;
typedef struct kefir_ast_alignment kefir_ast_alignment_t;
typedef struct kefir_ast_global_context kefir_ast_global_context_t;
typedef struct kefir_ast_local_context kefir_ast_local_context_t;
typedef struct kefir_ast_function_declaration_context kefir_ast_function_declaration_context_t;
typedef struct kefir_ast_visitor kefir_ast_visitor_t;
typedef struct kefir_ast_declarator_attributes kefir_ast_declarator_attributes_t;

#endif
