KEFIR_STANDALONE_SOURCE := $(SOURCE_DIR)/cc1/main.c \
	                       $(SOURCE_DIR)/cc1/options.c \
	                       $(SOURCE_DIR)/cc1/cc1.c \
						   $(SOURCE_DIR)/driver/runner.c \
						   $(SOURCE_DIR)/driver/compiler_options.c

KEFIR_STANDALONE_COMPILE_DEPS := $(KEFIR_STANDALONE_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.deps)
KEFIR_STANDALONE_DEPENDENCIES := $(KEFIR_STANDALONE_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.d)
KEFIR_STANDALONE_OBJECT_FILES := $(KEFIR_STANDALONE_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.o)

KEFIR_STANDALONE_LIBS=
ifeq ($(USE_SANITIZER),yes)
KEFIR_STANDALONE_LIBS=-fsanitize=undefined
endif

$(KEFIR_BIN_DIR)/cc1/help.binary.h: $(GENERATED_HELP_DIR)/kefir-cc1.1.txt
$(KEFIR_BIN_DIR)/cc1/help.binary.h: BINARY_HEADER_CONTENT=$(GENERATED_HELP_DIR)/kefir-cc1.1.txt --zero

$(KEFIR_CC1_EXE): $(KEFIR_STANDALONE_OBJECT_FILES) $(LIBKEFIR_DEPENDENCY)
	@mkdir -p $(shell dirname "$@")
	@echo "Linking $@"
ifeq ($(USE_SHARED),yes)
	@$(CCLD) -o $@ $(KEFIR_STANDALONE_OBJECT_FILES) $(KEFIR_STANDALONE_LIBS) -L $(LIB_DIR) -lkefir $(LDFLAGS)
else
	@$(CCLD) -static -o $@ $(KEFIR_STANDALONE_OBJECT_FILES) $(LIBKEFIR_A) $(KEFIR_STANDALONE_LIBS) $(LDFLAGS)
endif
ifneq (,$(findstring release,$(PROFILE)))
	@echo "Stripping $@"
	@$(STRIP) $@
endif

COMPILE_DEPS += $(KEFIR_STANDALONE_COMPILE_DEPS)
DEPENDENCIES += $(KEFIR_STANDALONE_DEPENDENCIES)
OBJECT_FILES += $(KEFIR_STANDALONE_OBJECT_FILES)
BINARIES += $(KEFIR_BIN_DIR)/kefir-cc1
