KEFIR_DRIVER_SOURCE := $(wildcard $(SOURCE_DIR)/driver/*.c)
KEFIR_DRIVER_SOURCE += $(SOURCE_DIR)/cc1/cc1.c
KEFIR_DRIVER_SOURCE += $(SOURCE_DIR)/cc1/options.c

KEFIR_DRIVER_COMPILE_DEPS := $(KEFIR_DRIVER_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.deps)
KEFIR_DRIVER_DEPENDENCIES := $(KEFIR_DRIVER_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.d)
KEFIR_DRIVER_OBJECT_FILES := $(KEFIR_DRIVER_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.o)

KEFIR_DRIVER_LIBS=
ifeq ($(USE_SANITIZER),yes)
KEFIR_DRIVER_LIBS=-fsanitize=undefined
endif

$(KEFIR_EXE): $(KEFIR_DRIVER_OBJECT_FILES) $(LIBKEFIR_DEPENDENCY)
	@mkdir -p $(shell dirname "$@")
	@echo "Linking $@"
ifeq ($(USE_SHARED),yes)
	@$(CCLD) -o $@ $(KEFIR_DRIVER_OBJECT_FILES) $(KEFIR_DRIVER_LIBS) -L $(LIB_DIR) -lkefir $(LDFLAGS)
else
	@$(CCLD) -static -o $@ $(KEFIR_DRIVER_OBJECT_FILES) $(LIBKEFIR_A) $(KEFIR_DRIVER_LIBS) $(LDFLAGS)
endif
ifneq (,$(findstring release,$(PROFILE)))
	@echo "Stripping $@"
	@$(STRIP) $@
endif

COMPILE_DEPS += $(KEFIR_DRIVER_COMPILE_DEPS)
DEPENDENCIES += $(KEFIR_DRIVER_DEPENDENCIES)
OBJECT_FILES += $(KEFIR_DRIVER_OBJECT_FILES)
BINARIES += $(KEFIR_BIN_DIR)/kefir
