KEFIR_BUILD_TIMESTAMP := $(shell date +%s)

$(BOOTSTRAP_DIR)/stage1/kefir: $(KEFIR_BIN_DIR)/kefir
	@echo "Bootstrapping $@"
	@LD_LIBRARY_PATH=$(KEFIR_BIN_DIR)/libs:$$LD_LIBRARY_PATH \
		KEFIR_RTINC=$(HEADERS_DIR)/kefir/runtime \
		$(MAKE) -f $(SOURCE_DIR)/tests/bootstrap/bootstrap.mk bootstrap \
		ROOT=$(ROOT) \
		SOURCE=$(SOURCE_DIR) \
		HEADERS=$(HEADERS_DIR) \
		BOOTSTRAP=$(BOOTSTRAP_DIR)/stage1 \
		BOOTSTRAP_CC=$(KEFIR_BIN_DIR)/kefir \
		KEFIR_BUILD_TIMESTAMP=$(KEFIR_BUILD_TIMESTAMP) \
		KEFIR_HOST_ENV_CONFIG_HEADER=$(KEFIR_HOST_ENV_CONFIG_HEADER) \
		GENERATED_HELP_DIR=$(GENERATED_HELP_DIR) \
		USE_SHARED=$(USE_SHARED)

$(BOOTSTRAP_DIR)/stage2/kefir: $(BOOTSTRAP_DIR)/stage1/kefir
	@echo "Bootstrapping $@"
	@LD_LIBRARY_PATH=$(BOOTSTRAP_DIR)/stage1:$$LD_LIBRARY_PATH \
		KEFIR_RTINC=$(HEADERS_DIR)/kefir/runtime \
		$(MAKE) -f $(SOURCE_DIR)/tests/bootstrap/bootstrap.mk bootstrap \
		ROOT=$(ROOT) \
		SOURCE=$(SOURCE_DIR) \
		HEADERS=$(HEADERS_DIR) \
		BOOTSTRAP=$(BOOTSTRAP_DIR)/stage2 \
		BOOTSTRAP_CC=$(BOOTSTRAP_DIR)/stage1/kefir \
		KEFIR_BUILD_TIMESTAMP=$(KEFIR_BUILD_TIMESTAMP) \
		KEFIR_HOST_ENV_CONFIG_HEADER=$(KEFIR_HOST_ENV_CONFIG_HEADER) \
		GENERATED_HELP_DIR=$(GENERATED_HELP_DIR) \
		USE_SHARED=$(USE_SHARED)

$(BOOTSTRAP_DIR)/stage2/comparison.done: $(BOOTSTRAP_DIR)/stage1/kefir $(BOOTSTRAP_DIR)/stage2/kefir
	@echo "Comparing stage1 and stage2 results"
	@$(SCRIPTS_DIR)/bootstrap_compare.sh "$(BOOTSTRAP_DIR)/stage1" "$(BOOTSTRAP_DIR)/stage2"
	@touch "$@"

BOOTSTRAP_TEST += $(BOOTSTRAP_DIR)/stage2/comparison.done
