
KEFIR_EXTERNAL_TEST_BASH_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/bash

KEFIR_EXTERNAL_TEST_BASH_VERSION := 5.2.21
KEFIR_EXTERNAL_TEST_BASH_ARCHIVE_FILENAME := bash-$(KEFIR_EXTERNAL_TEST_BASH_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_BASH_ARCHIVE := $(KEFIR_EXTERNAL_TEST_BASH_DIR)/bash-$(KEFIR_EXTERNAL_TEST_BASH_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_BASH_DIR)/bash-$(KEFIR_EXTERNAL_TEST_BASH_VERSION)
KEFIR_EXTERNAL_TEST_BASH_URL := https://ftp.gnu.org/gnu/bash/bash-$(KEFIR_EXTERNAL_TEST_BASH_VERSION).tar.gz

KEFIR_EXTERNAL_TEST_BASH_ARCHIVE_SHA256 := c8e31bdc59b69aaffc5b36509905ba3e5cbb12747091d27b4b977f078560d5b8

$(KEFIR_EXTERNAL_TEST_BASH_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_BASH_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_BASH_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_BASH_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_BASH_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_BASH_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_BASH_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_BASH_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)/Makefile: $(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring bash $(KEFIR_EXTERNAL_TEST_BASH_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		CFLAGS="-O1 -fPIC -pie" \
		./configure

$(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)/bash: $(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)/Makefile
	@echo "Building bash $(KEFIR_EXTERNAL_TEST_BASH_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) all

$(KEFIR_EXTERNAL_TEST_BASH_DIR)/tests.log: $(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)/bash
	@echo "Testing bash $(KEFIR_EXTERNAL_TEST_BASH_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_BASH_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) test 2>&1 | tee "$(shell realpath "$@.tmp")"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/bash.test.done: $(KEFIR_EXTERNAL_TEST_BASH_DIR)/tests.log
	@touch "$@"
	@echo "Bash $(KEFIR_EXTERNAL_TEST_BASH_VERSION) validation successfully finished"

EXTERNAL_TESTS_SLOW_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/bash.test.done
