KEFIR_EXTERNAL_TEST_C_TESTSUITE_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/c-testsuite

KEFIR_EXTERNAL_TEST_C_TESTSUITE_COMMIT_ID := a32b41ccbaf41b7cd31a714b50d725f56f6aabee
KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_FILENAME := c-testsuite-$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_COMMIT_ID).tar.gz
KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE := $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_DIR)/$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_C_TESTSUITE_URL := https://git.sr.ht/~jprotopopov/c-testsuite/archive/$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_COMMIT_ID).tar.gz

KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_SHA256=4364bc69e2dc3695fd570446dc4d755f10b50f10420726bccaabbdaecb3e0550

KEFIR_EXTERAL_TEST_C_TESTSUITE := $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_DIR)/c-testsuite-$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_COMMIT_ID)

KEFIR_EXTERNAL_TEST_C_TESTSUITE_CFLAGS := -O1 -fPIC -pie

$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_URL)..."
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERAL_TEST_C_TESTSUITE)/.extracted: $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE)
	@echo "Extracting c-testsuite $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_SHA256)..."
	@rm -rf "$(KEFIR_EXTERAL_TEST_C_TESTSUITE)"
	@cd "$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_DIR)/c-tests.log: $(KEFIR_EXTERAL_TEST_C_TESTSUITE)/.extracted $(KEFIR_EXE)
	@echo "Running c-testsuite $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_SHA256)..."
	@KEFIRCC="$(realpath $(KEFIR_EXE))" \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR)/runtime)" \
		CFLAGS="$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_CFLAGS)" \
		bash -c "set -o pipefail; cd $(KEFIR_EXTERAL_TEST_C_TESTSUITE); ./single-exec kefir 2>&1" | tee "$@.tmp"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/c-testsuite.test.done: $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_DIR)/c-tests.log
	@echo "Checking c-testsuite $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_SHA256) results..."
	@$(SOURCE_DIR)/tests/external/c-testsuite/validate.sh "$(KEFIR_EXTERNAL_TEST_C_TESTSUITE_DIR)/c-tests.log" "$(KEFIR_EXTERAL_TEST_C_TESTSUITE)"
	@touch "$@"
	@echo "c-testsuite $(KEFIR_EXTERNAL_TEST_C_TESTSUITE_ARCHIVE_SHA256) successfully finished"

EXTERNAL_TESTS_BASE_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/c-testsuite.test.done