
KEFIR_EXTERNAL_TEST_CELLO_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/cello

KEFIR_EXTERNAL_TEST_CELLO_VERSION := 61ee5c3d9bca98fd68af575e9704f5f02533ae26
KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE_FILENAME := $(KEFIR_EXTERNAL_TEST_CELLO_VERSION).zip
KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE := $(KEFIR_EXTERNAL_TEST_CELLO_DIR)/$(KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_CELLO_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_CELLO_DIR)/Cello-$(KEFIR_EXTERNAL_TEST_CELLO_VERSION)
KEFIR_EXTERNAL_TEST_CELLO_URL := https://github.com/orangeduck/Cello/archive/$(KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE_SHA256 := e95b2e3bba45ca97c70b412939fb3bac8a40c8e5296911667f06a3906bd9e4f3

$(KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_CELLO_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_CELLO_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_CELLO_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_CELLO_DIR)" && unzip "$(KEFIR_EXTERNAL_TEST_CELLO_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_CELLO_DIR)/tests.log: $(KEFIR_EXTERNAL_TEST_CELLO_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Building cello $(KEFIR_EXTERNAL_TEST_CELLO_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_CELLO_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		bash -c 'set -o pipefail; $(MAKE) check | tee "$(shell realpath $@.tmp)"'
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/cello.test.done: $(KEFIR_EXTERNAL_TEST_CELLO_DIR)/tests.log
	@"$(SOURCE_DIR)/tests/external/cello/validate.sh" $(KEFIR_EXTERNAL_TEST_CELLO_DIR)/tests.log
	@echo "Cello $(KEFIR_EXTERNAL_TEST_CELLO_VERSION) test suite successfully finished"
	@touch "$@"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/cello.test.done
