
KEFIR_EXTERNAL_TEST_CPROC_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/cproc

KEFIR_EXTERNAL_TEST_CPROC_VERSION := f66a661359a39e10af01508ad02429517b8460e3
KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE_FILENAME := $(KEFIR_EXTERNAL_TEST_CPROC_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE := $(KEFIR_EXTERNAL_TEST_CPROC_DIR)/$(KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_CPROC_DIR)/cproc-$(KEFIR_EXTERNAL_TEST_CPROC_VERSION)
KEFIR_EXTERNAL_TEST_CPROC_URL := https://git.sr.ht/~mcf/cproc/archive/$(KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE_SHA256 := 0998a6bfac3c1f1719151fb9e772a4a6a90c775c1332d0b02dcbadeca31e5b9b

$(KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_CPROC_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_CPROC_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_CPROC_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_CPROC_ARCHIVE_FILENAME)"
	@echo "Patching cproc $(KEFIR_EXTERNAL_TEST_CPROC_VERSION)..."
	@cd $(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR) && patch -p0 < "$(realpath $(SOURCE_DIR))/tests/external/cproc/cproc-$(KEFIR_EXTERNAL_TEST_CPROC_VERSION).patch"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)/config.h: $(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring cproc $(KEFIR_EXTERNAL_TEST_CPROC_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		./configure --host=$(shell $(CC) -dumpmachine)

$(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)/cproc-qbe: $(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)/config.h
	@echo "Building cproc $(KEFIR_EXTERNAL_TEST_CPROC_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE)

$(KEFIR_EXTERNAL_TEST_CPROC_DIR)/tests.log: $(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)/cproc-qbe
	@echo "Testing cproc $(KEFIR_EXTERNAL_TEST_CPROC_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_CPROC_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) check | tee "$(shell realpath $@.tmp)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/cproc.test.done: $(KEFIR_EXTERNAL_TEST_CPROC_DIR)/tests.log
	@$(SOURCE_DIR)/tests/external/cproc/validate.sh "$(KEFIR_EXTERNAL_TEST_CPROC_DIR)/tests.log"
	@touch "$@"
	@echo "Successfully tested cproc $(KEFIR_EXTERNAL_TEST_CPROC_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/cproc.test.done
