KEFIR_EXTERNAL_TEST_DUKTAPE_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/duktape

KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION := 2.7.0
KEFIR_EXTERNAL_TEST_DUKTAPE_ARCHIVE := duktape-$(KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION).tar.xz
KEFIR_EXTERNAL_TEST_DUKTAPE_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)/duktape-$(KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION)
KEFIR_EXTERNAL_TEST_DUKTAPE_URL := https://duktape.org/$(KEFIR_EXTERNAL_TEST_DUKTAPE_ARCHIVE)

KEFIR_EXTERNAL_TEST_DUKTAPE_ARCHIVE_SHA256=90f8d2fa8b5567c6899830ddef2c03f3c27960b11aca222fa17aa7ac613c2890

KEFIR_EXTERAL_TEST_DUKTAPE_EXE := $(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)/duktape-$(KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION)/duk

$(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)/$(KEFIR_EXTERNAL_TEST_DUKTAPE_ARCHIVE):
	@mkdir -p $(shell dirname $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_DUKTAPE_URL)..."
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_DUKTAPE_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_DUKTAPE_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"


$(KEFIR_EXTERAL_TEST_DUKTAPE_EXE): $(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)/$(KEFIR_EXTERNAL_TEST_DUKTAPE_ARCHIVE) $(KEFIR_EXE)
	@echo "Building Duktape $(KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION)..."
	@rm -rf "$(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)/duktape-$(KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION)"
	@cd "$(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)" && tar xvf "$(KEFIR_EXTERNAL_TEST_DUKTAPE_ARCHIVE)"
	@sed "s/^CCOPTS[ ]*=.*$$/CCOPTS = -O1 -fPIC -pie/g" "$(KEFIR_EXTERNAL_TEST_DUKTAPE_SOURCE_DIR)/Makefile.cmdline" > "$(KEFIR_EXTERNAL_TEST_DUKTAPE_SOURCE_DIR)/Makefile.kefir"
	@cd "$(KEFIR_EXTERNAL_TEST_DUKTAPE_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(shell $(REALPATH) $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(shell $(REALPATH) $(HEADERS_DIR)/runtime)" \
			$(MAKE) -f Makefile.kefir \
			CC="$(shell $(REALPATH) $(KEFIR_EXE))"

$(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)/test.log: $(KEFIR_EXTERAL_TEST_DUKTAPE_EXE)
	@echo "Running Duktape $(KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION)..."
	@"$(KEFIR_EXTERNAL_TEST_DUKTAPE_SOURCE_DIR)/duk" "$(KEFIR_EXTERNAL_TEST_DUKTAPE_SOURCE_DIR)/mandel.js" | tee "$@.tmp"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/duktape.test.done: $(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)/test.log
	@echo "Validating Duktape $(KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION)..."
	@diff "$(KEFIR_EXTERNAL_TEST_DUKTAPE_DIR)/test.log" "$(SOURCE_DIR)/tests/external/duktape/expected.log"
	@touch "$@"
	@echo "Duktape $(KEFIR_EXTERNAL_TEST_DUKTAPE_VERSION) successfully validated"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/duktape.test.done
