
KEFIR_EXTERNAL_TEST_GAWK_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/gawk

KEFIR_EXTERNAL_TEST_GAWK_VERSION := 5.3.1
KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE_FILENAME := gawk-$(KEFIR_EXTERNAL_TEST_GAWK_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE := $(KEFIR_EXTERNAL_TEST_GAWK_DIR)/$(KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_GAWK_DIR)/gawk-$(KEFIR_EXTERNAL_TEST_GAWK_VERSION)
KEFIR_EXTERNAL_TEST_GAWK_URL := https://ftp.gnu.org/gnu/gawk/gawk-$(KEFIR_EXTERNAL_TEST_GAWK_VERSION).tar.gz

KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE_SHA256 := fa41b3a85413af87fb5e3a7d9c8fa8d4a20728c67651185bb49c38a7f9382b1e

$(KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_GAWK_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_GAWK_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_GAWK_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_GAWK_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)/Makefile: $(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring gawk $(KEFIR_EXTERNAL_TEST_GAWK_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		./configure

$(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)/gawk: $(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)/Makefile
	@echo "Building gawk $(KEFIR_EXTERNAL_TEST_GAWK_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE)

$(KEFIR_EXTERNAL_TEST_GAWK_DIR)/tests.log: $(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)/gawk
	@echo "Testing gawk $(KEFIR_EXTERNAL_TEST_GAWK_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_GAWK_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) check | tee "$(shell realpath $@.tmp)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/gawk.test.done: $(KEFIR_EXTERNAL_TEST_GAWK_DIR)/tests.log
	@$(SOURCE_DIR)/tests/external/gawk/validate.sh "$(KEFIR_EXTERNAL_TEST_GAWK_DIR)/tests.log"
	@touch "$@"
	@echo "Successfully tested gawk $(KEFIR_EXTERNAL_TEST_GAWK_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/gawk.test.done
