KEFIR_EXTERNAL_TEST_GCC_TORTURE_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/gcc-torture

KEFIR_EXTERNAL_TEST_GCC_TORTURE_VERSION := 13.1.0

KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_FILENAME := gcc-$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_VERSION).tar.xz
KEFIR_EXTERNAL_TEST_GCC_URL := ftp://ftp.gnu.org/gnu/gcc/gcc-$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_VERSION)/gcc-$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_VERSION).tar.xz
KEFIR_EXTERNAL_TEST_GCC_ARCHIVE := $(KEFIR_EXTERNAL_TEST_GCC_TORTURE_DIR)/$(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_GCC_DIR := $(KEFIR_EXTERNAL_TEST_GCC_TORTURE_DIR)/gcc-$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_VERSION)

KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_SHA256 := 61d684f0aa5e76ac6585ad8898a2427aade8979ed5e7f85492286c4dfc13ee86

KEFIR_EXTERNAL_TEST_GCC_TORTURE_CFLAGS := -O1 -fPIC -pie -g

$(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE):
	@mkdir -p "$(dir $@)"
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_FILENAME)..."
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_GCC_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_GCC_DIR)/.done: $(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE)
	@echo "Unpacking $(basename $(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE))..."
	@rm -rf "$(KEFIR_EXTERNAL_TEST_GCC_DIR)"
	@cd "$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_DIR)" && \
		rm -f "$(basename $(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_FILENAME))" && \
		xz -d < "$(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_FILENAME)" > "$(basename $(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_FILENAME))"
	@cd "$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_DIR)" && tar xvf "$(basename $(KEFIR_EXTERNAL_TEST_GCC_ARCHIVE_FILENAME))"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_DIR)/torture.log: $(KEFIR_EXTERNAL_TEST_GCC_DIR)/.done $(KEFIR_EXE)
	@echo "Running GCC $(KEFIR_EXTERNAL_TEST_GCC_TORTURE_VERSION) torture test suite..."
	@TORTURE="$(KEFIR_EXTERNAL_TEST_GCC_DIR)/gcc/testsuite/gcc.c-torture" \
		KEFIRCC="$(realpath $(KEFIR_EXE))" \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR)/runtime)" \
		KEFIR_EXTRAFLAGS="$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_CFLAGS)" \
		"$(SOURCE_DIR)/tests/external/gcc-torture/run_gcc_torture_suite.sh" 2>&1 | tee "$@.tmp"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/gcc-torture.test.done: $(KEFIR_EXTERNAL_TEST_GCC_TORTURE_DIR)/torture.log
	@echo "Checking GCC $(KEFIR_EXTERNAL_TEST_GCC_TORTURE_VERSION) torture test suite results..."
	@"$(SOURCE_DIR)/tests/external/gcc-torture/validate.sh" "$(KEFIR_EXTERNAL_TEST_GCC_TORTURE_DIR)/torture.log"
	@touch "$@"
	@echo "GCC $(KEFIR_EXTERNAL_TEST_GCC_TORTURE_VERSION) torture test suite successfully finished"

KEFIR_GCC_TORTURE_TEST = $(KEFIR_EXTERNAL_TESTS_DIR)/gcc-torture.test.done
EXTERNAL_TESTS_BASE_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/gcc-torture.test.done
