
KEFIR_EXTERNAL_TEST_HUMMINGBIRD_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/hummingbird

KEFIR_EXTERNAL_TEST_HUMMINGBIRD_VERSION := 77a8cb87850d29c9fb94d354b66016d94d2adad2
KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE_FILENAME := $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_VERSION).zip
KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE := $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_DIR)/$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_HUMMINGBIRD_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_DIR)/hummingbird-$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_VERSION)
KEFIR_EXTERNAL_TEST_HUMMINGBIRD_URL := https://github.com/Sweets/hummingbird/archive/$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE_SHA256 := ba9a70ad4985331c1283a52fa242eb4d4bc5aa7f761c4eac862ac81e6fc912b5

$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_DIR)" && unzip -o "$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_SOURCE_DIR)/hummingbird: $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_SOURCE_DIR)/.extracted
	@echo "Building hummingbird $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) CC="$(realpath $(KEFIR_EXE))"

$(KEFIR_EXTERNAL_TESTS_DIR)/hummingbird.test.done: $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_SOURCE_DIR)/hummingbird
	@touch "$@"
	@echo "Successfully built hummingbird $(KEFIR_EXTERNAL_TEST_HUMMINGBIRD_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/hummingbird.test.done
