
KEFIR_EXTERNAL_TEST_LIBSIR_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/libsir

KEFIR_EXTERNAL_TEST_LIBSIR_VERSION := 2.2.4
KEFIR_EXTERNAL_TEST_LIBSIR_ARCHIVE_FILENAME := v$(KEFIR_EXTERNAL_TEST_LIBSIR_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_LIBSIR_ARCHIVE := $(KEFIR_EXTERNAL_TEST_LIBSIR_DIR)/v$(KEFIR_EXTERNAL_TEST_LIBSIR_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_LIBSIR_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_LIBSIR_DIR)/libsir-$(KEFIR_EXTERNAL_TEST_LIBSIR_VERSION)
KEFIR_EXTERNAL_TEST_LIBSIR_URL := https://github.com/aremmell/libsir/archive/refs/tags/v$(KEFIR_EXTERNAL_TEST_LIBSIR_VERSION).tar.gz

KEFIR_EXTERNAL_TEST_LIBSIR_ARCHIVE_SHA256 := a24fb74b38c1aecaf0b2671f63b3e1a75a27ac0ad20f6e570b0d1b0b9027abba

$(KEFIR_EXTERNAL_TEST_LIBSIR_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_LIBSIR_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_LIBSIR_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_LIBSIR_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_LIBSIR_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_LIBSIR_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_LIBSIR_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_LIBSIR_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_LIBSIR_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_LIBSIR_SOURCE_DIR)/build/bin/sirtests: $(KEFIR_EXTERNAL_TEST_LIBSIR_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Building libsir $(KEFIR_EXTERNAL_TEST_LIBSIR_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_LIBSIR_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE)

$(KEFIR_EXTERNAL_TESTS_DIR)/libsir.test.done: $(KEFIR_EXTERNAL_TEST_LIBSIR_SOURCE_DIR)/build/bin/sirtests
	@echo "Testing libsir $(KEFIR_EXTERNAL_TEST_LIBSIR_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_LIBSIR_SOURCE_DIR)" && ./build/bin/sirexample
	@cd "$(KEFIR_EXTERNAL_TEST_LIBSIR_SOURCE_DIR)" && ./build/bin/sirtests
	@touch "$@"
	@echo "libsir $(KEFIR_EXTERNAL_TEST_LIBSIR_VERSION) tests successfully finished"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/libsir.test.done
