
KEFIR_EXTERNAL_TEST_MUSL_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/musl

KEFIR_EXTERNAL_TEST_MUSL_VERSION := 1.2.5
KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE_FILENAME := musl-$(KEFIR_EXTERNAL_TEST_MUSL_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE := $(KEFIR_EXTERNAL_TEST_MUSL_DIR)/$(KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_MUSL_DIR)/musl-$(KEFIR_EXTERNAL_TEST_MUSL_VERSION)
KEFIR_EXTERNAL_TEST_MUSL_URL := https://musl.libc.org/releases/musl-$(KEFIR_EXTERNAL_TEST_MUSL_VERSION).tar.gz

KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE_SHA256 := a9a118bbe84d8764da0ea0d28b3ab3fae8477fc7e4085d90102b8596fc7c75e4

$(KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_MUSL_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_MUSL_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_MUSL_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_MUSL_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR)/config.mak: $(KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring musl $(KEFIR_EXTERNAL_TEST_MUSL_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		CROSS_COMPILE= \
		CFLAGS="-O1 -fPIC -pie" \
		./configure --target=x86_64

$(KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR)/lib/libc.so: $(KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR)/config.mak
	@echo "Building musl $(KEFIR_EXTERNAL_TEST_MUSL_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) all CROSS_COMPILE=

$(KEFIR_EXTERNAL_TESTS_DIR)/musl.test.done: $(KEFIR_EXTERNAL_TEST_MUSL_SOURCE_DIR)/lib/libc.so
	@touch "$@"
	@echo "Successfully built musl $(KEFIR_EXTERNAL_TEST_MUSL_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/musl.test.done
