
KEFIR_EXTERNAL_TEST_NANO_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/nano

KEFIR_EXTERNAL_TEST_NANO_VERSION := 7.2
KEFIR_EXTERNAL_TEST_NANO_ARCHIVE_FILENAME := nano-$(KEFIR_EXTERNAL_TEST_NANO_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_NANO_ARCHIVE := $(KEFIR_EXTERNAL_TEST_NANO_DIR)/$(KEFIR_EXTERNAL_TEST_NANO_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_NANO_DIR)/nano-$(KEFIR_EXTERNAL_TEST_NANO_VERSION)
KEFIR_EXTERNAL_TEST_NANO_URL := https://www.nano-editor.org/dist/v7/$(KEFIR_EXTERNAL_TEST_NANO_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_NANO_ARCHIVE_SHA256 := b4edaab0a037b5760484907c674e980053896f33759e43f834a212145fd085f1

$(KEFIR_EXTERNAL_TEST_NANO_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_NANO_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_NANO_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_NANO_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_NANO_ARCHIVE)
	@echo "Extracnanog $(KEFIR_EXTERNAL_TEST_NANO_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_NANO_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_NANO_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR)/Makefile: $(KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring nano $(KEFIR_EXTERNAL_TEST_NANO_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		CFLAGS="-O1 -fPIC -pie" \
		./configure

$(KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR)/src/nano: $(KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR)/Makefile
	@echo "Building nano $(KEFIR_EXTERNAL_TEST_NANO_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE)

$(KEFIR_EXTERNAL_TESTS_DIR)/nano.test.done: $(KEFIR_EXTERNAL_TEST_NANO_SOURCE_DIR)/src/nano
	@touch "$@"
	@echo "Successfully built nano $(KEFIR_EXTERNAL_TEST_NANO_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/nano.test.done
