KEFIR_EXTERNAL_TEST_NGINX_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/nginx

KEFIR_EXTERNAL_TEST_NGINX_VERSION := 1.27.3
KEFIR_EXTERNAL_TEST_NGINX_ARCHIVE := nginx-$(KEFIR_EXTERNAL_TEST_NGINX_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_NGINX_URL := https://nginx.org/download/$(KEFIR_EXTERNAL_TEST_NGINX_ARCHIVE)

KEFIR_EXTERNAL_TEST_NGINX_ARCHIVE_SHA256=ba23a9568f442036b61cd0e29bd66a47b90634efa91e0b2cf2d719057a9b7903

KEFIR_EXTERAL_TEST_NGINX_EXE := $(KEFIR_EXTERNAL_TEST_NGINX_DIR)/nginx-$(KEFIR_EXTERNAL_TEST_NGINX_VERSION)/objs/nginx

KEFIR_EXTERNAL_TEST_NGINX_CFLAGS := -O1 -fPIC -pie -D__GNUC__=2

$(KEFIR_EXTERNAL_TEST_NGINX_DIR)/$(KEFIR_EXTERNAL_TEST_NGINX_ARCHIVE):
	@mkdir -p $(shell dirname $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_NGINX_URL)..."
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_NGINX_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_NGINX_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_NGINX_DIR)/.configured: $(KEFIR_EXTERNAL_TEST_NGINX_DIR)/$(KEFIR_EXTERNAL_TEST_NGINX_ARCHIVE) $(KEFIR_EXE)
	@echo "Configuring Nginx $(KEFIR_EXTERNAL_TEST_NGINX_VERSION)..."
	@rm -rf "$(KEFIR_EXTERNAL_TEST_NGINX_DIR)/nginx-$(KEFIR_EXTERNAL_TEST_NGINX_VERSION)"
	@cd "$(KEFIR_EXTERNAL_TEST_NGINX_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_NGINX_ARCHIVE)"
	@cd "$(KEFIR_EXTERNAL_TEST_NGINX_DIR)/nginx-$(KEFIR_EXTERNAL_TEST_NGINX_VERSION)" && \
		LD_LIBRARY_PATH="$(shell $(REALPATH) $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(shell $(REALPATH) $(HEADERS_DIR)/runtime)" \
			CC="$(shell $(REALPATH) $(KEFIR_EXE))" \
			CFLAGS="$(KEFIR_EXTERNAL_TEST_NGINX_CFLAGS)" \
			./configure
	@touch "$@"

$(KEFIR_EXTERAL_TEST_NGINX_EXE): $(KEFIR_EXTERNAL_TEST_NGINX_DIR)/.configured
	@echo "Building Nginx $(KEFIR_EXTERNAL_TEST_NGINX_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_NGINX_DIR)/nginx-$(KEFIR_EXTERNAL_TEST_NGINX_VERSION)" && \
		LD_LIBRARY_PATH="$(shell $(REALPATH) $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(shell $(REALPATH) $(HEADERS_DIR)/runtime)" \
			$(MAKE)

$(KEFIR_EXTERNAL_TEST_NGINX_DIR)/test.log: $(KEFIR_EXTERAL_TEST_NGINX_EXE)
	@echo "Testing Nginx $(KEFIR_EXTERNAL_TEST_NGINX_VERSION)..."
	@"$(SOURCE_DIR)/tests/external/nginx/test.sh" "$(KEFIR_EXTERNAL_TEST_NGINX_DIR)/nginx-$(KEFIR_EXTERNAL_TEST_NGINX_VERSION)" "$@.tmp"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/nginx.test.done: $(KEFIR_EXTERNAL_TEST_NGINX_DIR)/test.log
	@diff "$(KEFIR_EXTERNAL_TEST_NGINX_DIR)/test.log" "$(SOURCE_DIR)/tests/external/nginx/expected.log"
	@touch "$@"
	@echo "Successfully tested Nginx $(KEFIR_EXTERNAL_TEST_NGINX_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/nginx.test.done
