
KEFIR_EXTERNAL_TEST_PFORTH_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/pforth

KEFIR_EXTERNAL_TEST_PFORTH_VERSION := 2.0.1
KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE_FILENAME := v$(KEFIR_EXTERNAL_TEST_PFORTH_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE := $(KEFIR_EXTERNAL_TEST_PFORTH_DIR)/$(KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_PFORTH_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_PFORTH_DIR)/pforth-$(KEFIR_EXTERNAL_TEST_PFORTH_VERSION)
KEFIR_EXTERNAL_TEST_PFORTH_URL := https://github.com/philburk/pforth/archive/refs/tags/$(KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE_SHA256 := f4c417d7d1f2c187716263484bdc534d3224b6d159e049d00828a89fa5d6894d

$(KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_PFORTH_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_PFORTH_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_PFORTH_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_PFORTH_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_PFORTH_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_PFORTH_SOURCE_DIR)/platforms/unix/pforth_standalone: $(KEFIR_EXTERNAL_TEST_PFORTH_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring pforth $(KEFIR_EXTERNAL_TEST_PFORTH_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_PFORTH_SOURCE_DIR)/platforms/unix" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE)

$(KEFIR_EXTERNAL_TEST_PFORTH_DIR)/tests.log: $(KEFIR_EXTERNAL_TEST_PFORTH_SOURCE_DIR)/platforms/unix/pforth_standalone
	@echo "Testing pforth $(KEFIR_EXTERNAL_TEST_PFORTH_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_PFORTH_SOURCE_DIR)/platforms/unix" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) test | tee "$(shell realpath $@.tmp)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/pforth.test.done: $(KEFIR_EXTERNAL_TEST_PFORTH_DIR)/tests.log
	@$(SOURCE_DIR)/tests/external/pforth/validate.sh "$(KEFIR_EXTERNAL_TEST_PFORTH_DIR)/tests.log"
	@touch "$@"
	@echo "Successfully tested pforth $(KEFIR_EXTERNAL_TEST_PFORTH_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/pforth.test.done
