
KEFIR_EXTERNAL_TEST_PUREDOOM_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/PureDOOM

KEFIR_EXTERNAL_TEST_PUREDOOM_VERSION := 48376ddd6bbdb70085dab91feb1c6ceef80fa9b7
KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE_FILENAME := $(KEFIR_EXTERNAL_TEST_PUREDOOM_VERSION).zip
KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE := $(KEFIR_EXTERNAL_TEST_PUREDOOM_DIR)/$(KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_PUREDOOM_DIR)/PureDOOM-$(KEFIR_EXTERNAL_TEST_PUREDOOM_VERSION)
KEFIR_EXTERNAL_TEST_PUREDOOM_URL := https://github.com/Daivuk/PureDOOM/archive/$(KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE_SHA256 := bd13089fdd1dc305e16fc15e95d73de252aebde9617f4fa6bf9a16d417e34e6f

$(KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_PUREDOOM_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_PUREDOOM_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE_FILENAME)..."
	@rm -rf "$(KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR)"
	@cd "$(KEFIR_EXTERNAL_TEST_PUREDOOM_DIR)" && unzip "$(KEFIR_EXTERNAL_TEST_PUREDOOM_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR)/examples/Tests/build/Makefile: $(KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring PureDOOM $(KEFIR_EXTERNAL_TEST_PUREDOOM_VERSION) tests..."
	@mkdir -p "$(dir $@)"
	@cd "$(dir $@)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		cmake ..

$(KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR)/examples/Tests/build/pd_tests: $(KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR)/examples/Tests/build/Makefile
	@echo "Building PureDOOM $(KEFIR_EXTERNAL_TEST_PUREDOOM_VERSION) tests..."
	@cd "$(dir $@)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE)

$(KEFIR_EXTERNAL_TEST_PUREDOOM_DIR)/tests.log: $(KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR)/examples/Tests/build/pd_tests
	@echo "Testing PureDOOM $(KEFIR_EXTERNAL_TEST_PUREDOOM_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_PUREDOOM_SOURCE_DIR)" && \
		examples/Tests/build/pd_tests | tee "$(shell realpath $@.tmp)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/PureDOOM.test.done: $(KEFIR_EXTERNAL_TEST_PUREDOOM_DIR)/tests.log
	@$(SOURCE_DIR)/tests/external/puredoom/validate.sh "$(KEFIR_EXTERNAL_TEST_PUREDOOM_DIR)/tests.log"
	@touch "$@"
	@echo "Successfully tested PureDOOM $(KEFIR_EXTERNAL_TEST_PUREDOOM_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/PureDOOM.test.done
