
KEFIR_EXTERNAL_TEST_SDL2_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/sdl2

KEFIR_EXTERNAL_TEST_SDL2_VERSION := 2.30.10
KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE_FILENAME := SDL2-$(KEFIR_EXTERNAL_TEST_SDL2_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE := $(KEFIR_EXTERNAL_TEST_SDL2_DIR)/$(KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_SDL2_DIR)/SDL2-$(KEFIR_EXTERNAL_TEST_SDL2_VERSION)
KEFIR_EXTERNAL_TEST_SDL2_URL := https://github.com/libsdl-org/SDL/releases/download/release-$(KEFIR_EXTERNAL_TEST_SDL2_VERSION)/SDL2-$(KEFIR_EXTERNAL_TEST_SDL2_VERSION).tar.gz

KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE_SHA256 := f59adf36a0fcf4c94198e7d3d776c1b3824211ab7aeebeb31fe19836661196aa

$(KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_SDL2_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_SDL2_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE)
	@echo "Extracted sdl2 $(KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_SDL2_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_SDL2_ARCHIVE_FILENAME)"
	@echo "Patching sdl2 $(KEFIR_EXTERNAL_TEST_SDL2_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)" && patch -p0 < "$(realpath $(SOURCE_DIR))/tests/external/sdl2/sdl2-2.30.10.patch"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)/Makefile: $(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring sdl2 $(KEFIR_EXTERNAL_TEST_SDL2_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		./configure

$(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)/build/libSDL2.la: $(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)/Makefile
	@echo "Building sdl2 $(KEFIR_EXTERNAL_TEST_SDL2_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE)

$(KEFIR_EXTERNAL_TESTS_DIR)/sdl2.test.done: $(KEFIR_EXTERNAL_TEST_SDL2_SOURCE_DIR)/build/libSDL2.la
	@touch "$@"
	@echo "Successfully built sdl2 $(KEFIR_EXTERNAL_TEST_SDL2_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/sdl2.test.done
