
KEFIR_EXTERNAL_TEST_SLIMCC_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/slimcc

KEFIR_EXTERNAL_TEST_SLIMCC_VERSION := 5b1d37bf8349fc9dac7a4592bbc4e582c705e326
KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE_FILENAME := $(KEFIR_EXTERNAL_TEST_SLIMCC_VERSION).zip
KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE := $(KEFIR_EXTERNAL_TEST_SLIMCC_DIR)/$(KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_SLIMCC_DIR)/slimcc-$(KEFIR_EXTERNAL_TEST_SLIMCC_VERSION)
KEFIR_EXTERNAL_TEST_SLIMCC_URL := https://github.com/fuhsnn/slimcc/archive/$(KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE_SHA256 := 537b0106b0473b9b411cd1c05a331c1ae4ba397afb0007d38b3b2f0e011321f2

$(KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_SLIMCC_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_SLIMCC_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE)
	@rm -rf "$(KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR)"
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_SLIMCC_DIR)" && \
		unzip "$(KEFIR_EXTERNAL_TEST_SLIMCC_ARCHIVE_FILENAME)"
	@echo "Patching slimcc $(KEFIR_EXTERNAL_TEST_SLIMCC_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR)" && patch -p0 < "$(realpath $(SOURCE_DIR))/tests/external/slimcc/slimcc-$(KEFIR_EXTERNAL_TEST_SLIMCC_VERSION).patch"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR)/slimcc: $(KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR)/.extracted
	@echo "Building slimcc $(KEFIR_EXTERNAL_TEST_SLIMCC_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE)

$(KEFIR_EXTERNAL_TEST_SLIMCC_DIR)/test.log: $(KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR)/slimcc
	@echo "Testing slimcc $(KEFIR_EXTERNAL_TEST_SLIMCC_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_SLIMCC_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) test | tee "$(shell realpath $@.tmp)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/slimcc.test.done: $(KEFIR_EXTERNAL_TEST_SLIMCC_DIR)/test.log
	@$(SOURCE_DIR)/tests/external/slimcc/validate.sh "$(KEFIR_EXTERNAL_TEST_SLIMCC_DIR)/test.log"
	@touch "$@"
	@echo "Successfully tested slimcc $(KEFIR_EXTERNAL_TEST_SLIMCC_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/slimcc.test.done
