
KEFIR_EXTERNAL_TEST_TCC_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/tcc

KEFIR_EXTERNAL_TEST_TCC_VERSION := f6385c05308f715bdd2c06336801193a21d69b50
KEFIR_EXTERNAL_TEST_TCC_ARCHIVE_FILENAME := tcc-$(KEFIR_EXTERNAL_TEST_TCC_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_TCC_ARCHIVE := $(KEFIR_EXTERNAL_TEST_TCC_DIR)/$(KEFIR_EXTERNAL_TEST_TCC_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_TCC_DIR)/tinycc-f6385c0
KEFIR_EXTERNAL_TEST_TCC_URL := https://repo.or.cz/tinycc.git/snapshot/$(KEFIR_EXTERNAL_TEST_TCC_VERSION).tar.gz

KEFIR_EXTERNAL_TEST_TCC_ARCHIVE_SHA256 := fa807a4987e8867435fda584b89f6fa39e8f1ba1c029de97a486365f62f90463

$(KEFIR_EXTERNAL_TEST_TCC_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_TCC_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_TCC_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_TCC_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_TCC_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_TCC_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TCC_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_TCC_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)/config.h: $(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring tcc $(KEFIR_EXTERNAL_TEST_TCC_VERSION)..."
	@rm -f "$@"
	@cd "$(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		./configure --cc="$(realpath $(KEFIR_EXE))" --extra-cflags="-O1 -fPIC -pie"

$(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)/tcc: $(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)/config.h
	@echo "Building tcc $(KEFIR_EXTERNAL_TEST_TCC_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) all

$(KEFIR_EXTERNAL_TESTS_DIR)/tcc.test.done: $(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)/tcc
	@echo "Testing tcc $(KEFIR_EXTERNAL_TEST_TCC_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TCC_SOURCE_DIR)/tests/tests2" && $(MAKE) test
	@touch "$@"
	@echo "Successfully validated tcc $(KEFIR_EXTERNAL_TEST_TCC_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/tcc.test.done
