
KEFIR_EXTERNAL_TEST_TIN_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/tin

KEFIR_EXTERNAL_TEST_TIN_VERSION := 2.6.3
KEFIR_EXTERNAL_TEST_TIN_ARCHIVE_FILENAME := tin-$(KEFIR_EXTERNAL_TEST_TIN_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_TIN_ARCHIVE := $(KEFIR_EXTERNAL_TEST_TIN_DIR)/$(KEFIR_EXTERNAL_TEST_TIN_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_TIN_DIR)/tin-$(KEFIR_EXTERNAL_TEST_TIN_VERSION)
KEFIR_EXTERNAL_TEST_TIN_URL := ftp://ftp.tin.org/pub/news/clients/tin/v2.6/tin-$(KEFIR_EXTERNAL_TEST_TIN_VERSION).tar.gz

KEFIR_EXTERNAL_TEST_TIN_ARCHIVE_SHA256 := 8386202ce600d5580d04beb6ac6fca16427378b6ee2d1efb27a779f8505fbcda

$(KEFIR_EXTERNAL_TEST_TIN_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_TIN_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_TIN_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_TIN_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_TIN_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_TIN_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TIN_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_TIN_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR)/config.log: $(KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring tin $(KEFIR_EXTERNAL_TEST_TIN_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		CFLAGS="-O1 -fPIC -pie" \
		./configure

$(KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR)/src/tin: $(KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR)/config.log
	@echo "Building tin $(KEFIR_EXTERNAL_TEST_TIN_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) build

$(KEFIR_EXTERNAL_TESTS_DIR)/tin.test.done: $(KEFIR_EXTERNAL_TEST_TIN_SOURCE_DIR)/src/tin
	@touch "$@"
	@echo "Successfully built tin $(KEFIR_EXTERNAL_TEST_TIN_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/tin.test.done
