
KEFIR_EXTERNAL_TEST_TOYBOX_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/toybox

KEFIR_EXTERNAL_TEST_TOYBOX_VERSION := 0.8.12
KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE_FILENAME := toybox-$(KEFIR_EXTERNAL_TEST_TOYBOX_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE := $(KEFIR_EXTERNAL_TEST_TOYBOX_DIR)/$(KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_TOYBOX_DIR)/toybox-$(KEFIR_EXTERNAL_TEST_TOYBOX_VERSION)
KEFIR_EXTERNAL_TEST_TOYBOX_URL := https://landley.net/toybox/downloads/$(KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE_SHA256 := ad88a921133ae2231d9f2df875ec0bd42af4429145caea7d7db9e02208a6fd2e

$(KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_TOYBOX_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_TOYBOX_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TOYBOX_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_TOYBOX_ARCHIVE_FILENAME)"
	@echo "Patching toybox $(KEFIR_EXTERNAL_TEST_TOYBOX_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)" && patch -p0 < "$(realpath $(SOURCE_DIR))/tests/external/toybox/toybox-$(KEFIR_EXTERNAL_TEST_TOYBOX_VERSION).patch"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)/generated/config.h: $(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring toybox $(KEFIR_EXTERNAL_TEST_TOYBOX_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) CC="$(realpath $(KEFIR_EXE))" HOSTCC="$(realpath $(KEFIR_EXE))" defconfig

$(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)/toybox: $(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)/generated/config.h
	@echo "Building toybox $(KEFIR_EXTERNAL_TEST_TOYBOX_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) CC="$(realpath $(KEFIR_EXE))" HOSTCC="$(realpath $(KEFIR_EXE))"

$(KEFIR_EXTERNAL_TEST_TOYBOX_DIR)/tests.log: $(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)/toybox
	@echo "Testing toybox $(KEFIR_EXTERNAL_TEST_TOYBOX_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_TOYBOX_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) CC="$(realpath $(KEFIR_EXE))" HOSTCC="$(realpath $(KEFIR_EXE))" tests | tee "$(shell realpath $@.tmp)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/toybox.test.done: $(KEFIR_EXTERNAL_TEST_TOYBOX_DIR)/tests.log
	@$(SOURCE_DIR)/tests/external/toybox/validate.sh "$(KEFIR_EXTERNAL_TEST_TOYBOX_DIR)/tests.log"
	@touch "$@"
	@echo "Successfully tested toybox $(KEFIR_EXTERNAL_TEST_TOYBOX_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/toybox.test.done
