
KEFIR_EXTERNAL_TEST_VIM_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/vim

KEFIR_EXTERNAL_TEST_VIM_VERSION := 9.1.0990
KEFIR_EXTERNAL_TEST_VIM_ARCHIVE_FILENAME := v$(KEFIR_EXTERNAL_TEST_VIM_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_VIM_ARCHIVE := $(KEFIR_EXTERNAL_TEST_VIM_DIR)/$(KEFIR_EXTERNAL_TEST_VIM_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_VIM_DIR)/vim-$(KEFIR_EXTERNAL_TEST_VIM_VERSION)
KEFIR_EXTERNAL_TEST_VIM_URL := https://github.com/vim/vim/archive/refs/tags/$(KEFIR_EXTERNAL_TEST_VIM_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_VIM_ARCHIVE_SHA256 := d5c23a86cd21c5f94896867e54ae873b9aedab473b72c83755e3a154cd692d91

$(KEFIR_EXTERNAL_TEST_VIM_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_VIM_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_VIM_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_VIM_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_VIM_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_VIM_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_VIM_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_VIM_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)/src/auto/config.h: $(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring vim $(KEFIR_EXTERNAL_TEST_VIM_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		./configure --with-features=normal

$(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)/src/vim: $(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)/src/auto/config.h
	@echo "Building vim $(KEFIR_EXTERNAL_TEST_VIM_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE)

$(KEFIR_EXTERNAL_TESTS_DIR)/vim.test.done: $(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)/src/vim
	@echo "Testing vim $(KEFIR_EXTERNAL_TEST_VIM_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_VIM_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) test -j1
	@echo "Vim $(KEFIR_EXTERNAL_TEST_VIM_VERSION) test suite successfully finished"
	@touch "$@"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/vim.test.done
