
KEFIR_EXTERNAL_TEST_YASM_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/yasm

KEFIR_EXTERNAL_TEST_YASM_VERSION := 1.3.0
KEFIR_EXTERNAL_TEST_YASM_ARCHIVE_FILENAME := yasm-$(KEFIR_EXTERNAL_TEST_YASM_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_YASM_ARCHIVE := $(KEFIR_EXTERNAL_TEST_YASM_DIR)/$(KEFIR_EXTERNAL_TEST_YASM_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_YASM_DIR)/yasm-$(KEFIR_EXTERNAL_TEST_YASM_VERSION)
KEFIR_EXTERNAL_TEST_YASM_URL := http://www.tortall.net/projects/yasm/releases/yasm-$(KEFIR_EXTERNAL_TEST_YASM_VERSION).tar.gz

KEFIR_EXTERNAL_TEST_YASM_ARCHIVE_SHA256 := 3dce6601b495f5b3d45b59f7d2492a340ee7e84b5beca17e48f862502bd5603f

$(KEFIR_EXTERNAL_TEST_YASM_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_YASM_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_YASM_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_YASM_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_YASM_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_YASM_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_YASM_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_YASM_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)/config.log: $(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring yasm $(KEFIR_EXTERNAL_TEST_YASM_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		CFLAGS="-O1 -fPIC -pie" \
		./configure

$(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)/yasm: $(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)/config.log
	@echo "Building yasm $(KEFIR_EXTERNAL_TEST_YASM_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) all


$(KEFIR_EXTERNAL_TEST_YASM_DIR)/tests.log: $(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)/yasm
	@echo "Building yasm $(KEFIR_EXTERNAL_TEST_YASM_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_YASM_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) check -j1 | tee "$(shell realpath $@.tmp)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TESTS_DIR)/yasm.test.done: $(KEFIR_EXTERNAL_TEST_YASM_DIR)/tests.log
	@$(SOURCE_DIR)/tests/external/yasm/validate.sh "$(KEFIR_EXTERNAL_TEST_YASM_DIR)/tests.log"
	@touch "$@"
	@echo "Successfully built yasm $(KEFIR_EXTERNAL_TEST_YASM_VERSION)"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/yasm.test.done
