
KEFIR_EXTERNAL_TEST_ZLIB_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/zlib

KEFIR_EXTERNAL_TEST_ZLIB_VERSION := 1.3.1
KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE_FILENAME := zlib-$(KEFIR_EXTERNAL_TEST_ZLIB_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE := $(KEFIR_EXTERNAL_TEST_ZLIB_DIR)/zlib-$(KEFIR_EXTERNAL_TEST_ZLIB_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_ZLIB_DIR)/zlib-$(KEFIR_EXTERNAL_TEST_ZLIB_VERSION)
KEFIR_EXTERNAL_TEST_ZLIB_URL := https://www.zlib.net/$(KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE_SHA256 := 9a93b2b7dfdac77ceba5a558a580e74667dd6fede4585b91eefb60f03b72df23

$(KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_ZLIB_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_ZLIB_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZLIB_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_ZLIB_ARCHIVE_FILENAME)"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)/configure.log: $(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Configuring zlib $(KEFIR_EXTERNAL_TEST_ZLIB_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		CFLAGS="-O1 -fPIC -pie" \
		./configure

$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)/libz.a: $(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)/configure.log
	@echo "Building zlib $(KEFIR_EXTERNAL_TEST_ZLIB_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) all

$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)/.t: $(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)/configure.log
	@echo "Building zlib $(KEFIR_EXTERNAL_TEST_ZLIB_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) all

$(KEFIR_EXTERNAL_TESTS_DIR)/zlib.test.done: $(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)/libz.a
	@echo "Testing zlib $(KEFIR_EXTERNAL_TEST_ZLIB_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		$(MAKE) test
	@cd "$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)" && ./example
	@cd "$(KEFIR_EXTERNAL_TEST_ZLIB_SOURCE_DIR)" && ./example64
	@touch "$@"
	@echo "Zlib $(KEFIR_EXTERNAL_TEST_ZLIB_VERSION) test successfully finished"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/zlib.test.done
