
KEFIR_EXTERNAL_TEST_ZSTD_DIR := $(KEFIR_EXTERNAL_TESTS_DIR)/zstd

KEFIR_EXTERNAL_TEST_ZSTD_VERSION := 1.5.6
KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE_FILENAME := v$(KEFIR_EXTERNAL_TEST_ZSTD_VERSION).tar.gz
KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE := $(KEFIR_EXTERNAL_TEST_ZSTD_DIR)/$(KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE_FILENAME)
KEFIR_EXTERNAL_TEST_ZSTD_SOURCE_DIR := $(KEFIR_EXTERNAL_TEST_ZSTD_DIR)/zstd-$(KEFIR_EXTERNAL_TEST_ZSTD_VERSION)
KEFIR_EXTERNAL_TEST_ZSTD_URL := https://github.com/facebook/zstd/archive/refs/tags/$(KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE_FILENAME)

KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE_SHA256 := 30f35f71c1203369dc979ecde0400ffea93c27391bfd2ac5a9715d2173d92ff7

$(KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE):
	@mkdir -p $(dir $@)
	@echo "Downloading $(KEFIR_EXTERNAL_TEST_ZSTD_URL)"
	@wget -O "$@.tmp" "$(KEFIR_EXTERNAL_TEST_ZSTD_URL)"
	@$(SCRIPTS_DIR)/checksum_sha256.sh "$@.tmp" "$(KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE_SHA256)"
	@mv "$@.tmp" "$@"

$(KEFIR_EXTERNAL_TEST_ZSTD_SOURCE_DIR)/.extracted: $(KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE)
	@echo "Extracting $(KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE_FILENAME)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZSTD_DIR)" && tar xvfz "$(KEFIR_EXTERNAL_TEST_ZSTD_ARCHIVE_FILENAME)"
	@echo "Patching zstd $(KEFIR_EXTERNAL_TEST_ZSTD_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZSTD_SOURCE_DIR)" && patch -p0 < "$(realpath $(SOURCE_DIR))/tests/external/zstd/zstd-$(KEFIR_EXTERNAL_TEST_ZSTD_VERSION).patch"
	@touch "$@"

$(KEFIR_EXTERNAL_TEST_ZSTD_SOURCE_DIR)/zstd: $(KEFIR_EXTERNAL_TEST_ZSTD_SOURCE_DIR)/.extracted $(KEFIR_EXE)
	@echo "Building zstd $(KEFIR_EXTERNAL_TEST_ZSTD_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZSTD_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE)

$(KEFIR_EXTERNAL_TESTS_DIR)/zstd.test.done: $(KEFIR_EXTERNAL_TEST_ZSTD_SOURCE_DIR)/zstd
	@echo "Testing zstd $(KEFIR_EXTERNAL_TEST_ZSTD_VERSION)..."
	@cd "$(KEFIR_EXTERNAL_TEST_ZSTD_SOURCE_DIR)" && \
		LD_LIBRARY_PATH="$(realpath $(LIB_DIR)):$$LD_LIBRARY_PATH" \
		KEFIR_RTINC="$(realpath $(HEADERS_DIR))/kefir/runtime" \
		CC="$(realpath $(KEFIR_EXE))" \
		$(MAKE) check
	@touch "$@"
	@echo "zstd $(KEFIR_EXTERNAL_TEST_ZSTD_VERSION) test successfully finished"

EXTERNAL_TESTS_FAST_SUITE += $(KEFIR_EXTERNAL_TESTS_DIR)/zstd.test.done
