KEFIR_SYSTEM_TESTS_TEST_SOURCES := $(wildcard \
	$(SOURCE_DIR)/tests/system/codegen/*.gen.c \
	$(SOURCE_DIR)/tests/system/parser/*.gen.c \
	$(SOURCE_DIR)/tests/system/translator/*.gen.c)
KEFIR_SYSTEM_TESTS_ALL_SOURCES = $(KEFIR_SYSTEM_TESTS_TEST_SOURCES)
KEFIR_SYSTEM_TESTS_ALL_SOURCES += $(SOURCE_DIR)/tests/int_test.c
KEFIR_SYSTEM_TESTS_ALL_SOURCES += $(SOURCE_DIR)/tests/util/util.c
KEFIR_SYSTEM_TESTS_ALL_SOURCES += $(SOURCE_DIR)/tests/util/codegen.c
KEFIR_SYSTEM_TESTS_ALL_SOURCES += $(SOURCE_DIR)/tests/util/module_shim.c
KEFIR_SYSTEM_TESTS_COMPILE_DEPS := $(KEFIR_SYSTEM_TESTS_ALL_SOURCES:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.deps)
KEFIR_SYSTEM_TESTS_DEPENDENCIES := $(KEFIR_SYSTEM_TESTS_ALL_SOURCES:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.d)
KEFIR_SYSTEM_TESTS_OBJECT_FILES := $(KEFIR_SYSTEM_TESTS_ALL_SOURCES:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.o)
KEFIR_SYSTEM_TESTS_GENERATORS := $(KEFIR_SYSTEM_TESTS_TEST_SOURCES:$(SOURCE_DIR)/tests/system/%.gen.c=$(KEFIR_BIN_DIR)/tests/system/%.gen)
KEFIR_SYSTEM_TESTS_DONE := $(KEFIR_SYSTEM_TESTS_TEST_SOURCES:$(SOURCE_DIR)/tests/system/%.gen.c=$(KEFIR_BIN_DIR)/tests/system/%.test.done)

KEFIR_SYSTEM_TEST_LIBS=
ifeq ($(USE_SANITIZER),yes)
KEFIR_SYSTEM_TEST_LIBS=-fsanitize=undefined
endif

ifeq ($(USE_SHARED),yes)
KEFIR_SYSTEM_TEST_LIBS+=-L $(LIB_DIR) -lkefir
else
KEFIR_SYSTEM_TEST_LIBS+=$(LIBKEFIR_A)
endif

KEFIR_SYSTEM_TEST_GEN_COMMON_OBJECT_FILES := $(KEFIR_BIN_DIR)/tests/int_test.o \
							                 $(KEFIR_BIN_DIR)/tests/util/util.o \
	                             			 $(KEFIR_BIN_DIR)/tests/util/module_shim.o \
							                 $(KEFIR_BIN_DIR)/tests/util/codegen.o

$(KEFIR_BIN_DIR)/tests/system/%.gen: $(KEFIR_BIN_DIR)/tests/system/%.gen.o \
							   $(LIBKEFIR_DEPENDENCY) \
							   $(KEFIR_SYSTEM_TEST_GEN_COMMON_OBJECT_FILES)
	@mkdir -p $(@D)
	@echo "Linking $@"
	@$(CC) -o $@ $(KEFIR_SYSTEM_TEST_GEN_COMMON_OBJECT_FILES) $< $(KEFIR_SYSTEM_TEST_LIBS) $(LDFLAGS)

$(KEFIR_BIN_DIR)/tests/system/%.test.done: $(KEFIR_BIN_DIR)/tests/system/%.gen
	@CC="$(CC)" \
	 AS="$(AS)" \
	 PROFILE_CFLAGS="$(PROFILE_CFLAGS)" \
	 EXTRA_CFLAGS="$(EXTRA_CFLAGS)" \
	 EXTRA_LDFLAGS="$(EXTRA_LDFLAGS)" \
	 TEST_CFLAGS="$(TEST_CFLAGS)" \
	 LD_LIBRARY_PATH="$(LIB_DIR):$$LD_LIBRARY_PATH" \
	 USE_VALGRIND="$(USE_VALGRIND)" \
	 USE_SANITIZER="$(USE_SANITIZER)" \
	 VALGRIND_TEST_OPTIONS="$(VALGRIND_TEST_OPTIONS)" \
	 PLATFORM="$(PLATFORM)" \
	 	"$(SOURCE_DIR)/tests/system/run.sh" $^
	@touch $@

COMPILE_DEPS += $(KEFIR_SYSTEM_TESTS_COMPILE_DEPS)
DEPENDENCIES += $(KEFIR_SYSTEM_TESTS_DEPENDENCIES)
OBJECT_FILES += $(KEFIR_SYSTEM_TESTS_OBJECT_FILES)
TEST_BINARIES += $(KEFIR_SYSTEM_TESTS_GENERATORS)
TESTS += $(KEFIR_SYSTEM_TESTS_DONE)