KEFIR_UNIT_TEST_SOURCE := $(wildcard \
	$(SOURCE_DIR)/tests/unit_test.c \
	$(SOURCE_DIR)/tests/util/util.c \
	$(SOURCE_DIR)/cc1/options.c \
	$(SOURCE_DIR)/driver/compiler_options.c \
	$(SOURCE_DIR)/tests/unit/*.c)
KEFIR_UNIT_TEST_COMPILE_DEPS := $(KEFIR_UNIT_TEST_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.deps)
KEFIR_UNIT_TEST_DEPENDENCIES := $(KEFIR_UNIT_TEST_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.d)
KEFIR_UNIT_TEST_OBJECT_FILES := $(KEFIR_UNIT_TEST_SOURCE:$(SOURCE_DIR)/%.c=$(KEFIR_BIN_DIR)/%.o)

KEFIR_UNIT_TEST_LIBS=
ifeq ($(USE_SANITIZER),yes)
KEFIR_UNIT_TEST_LIBS=-fsanitize=undefined
endif

ifeq ($(USE_SHARED),yes)
KEFIR_UNIT_TEST_LIBS+=-L $(LIB_DIR) -lkefir
else
KEFIR_UNIT_TEST_LIBS+=$(LIBKEFIR_A)
endif

$(KEFIR_BIN_DIR)/tests/unit.tests: $(LIBKEFIR_DEPENDENCY) $(KEFIR_UNIT_TEST_OBJECT_FILES)
	@mkdir -p $(@D)
	@echo "Linking $@"
	@$(CC) -o $@ $(KEFIR_UNIT_TEST_OBJECT_FILES) $(KEFIR_UNIT_TEST_LIBS) -lm $(LDFLAGS)

$(KEFIR_BIN_DIR)/tests/unit.tests.done: $(KEFIR_BIN_DIR)/tests/unit.tests
	@LD_LIBRARY_PATH=$$LD_LIBRARY_PATH:$(LIB_DIR) \
	 VALGRIND_TEST_OPTIONS="$(VALGRIND_TEST_OPTIONS)" \
	 USE_VALGRIND="$(USE_VALGRIND)" \
	 	$(SOURCE_DIR)/tests/unit/run.sh $^
	@touch $@

COMPILE_DEPS += $(KEFIR_UNIT_TEST_COMPILE_DEPS)
DEPENDENCIES += $(KEFIR_UNIT_TEST_DEPENDENCIES)
OBJECT_FILES += $(KEFIR_UNIT_TEST_OBJECT_FILES)
TEST_BINARIES += $(KEFIR_UNIT_TESTS_EXE)
TESTS += $(KEFIR_BIN_DIR)/tests/unit.tests.done
